"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
/**
 * Attempts to resolve the config file in a given root directory.
 * @param {string} rootDir - the directory to find the config file in.
 * @param {string} configName - the name of the config file.
 * @return {object} an object containing the config module and its path.
 */
function getConfigFile(rootDir, configName) {
    var configPath = path_1.default.join(rootDir, configName);
    var configFilePath = "";
    var configModule;
    try {
        configFilePath = require.resolve(configPath);
        configModule = require(configFilePath);
    }
    catch (err) {
        return {};
    }
    return { configModule: configModule, configFilePath: configFilePath };
}
exports.default = getConfigFile;
//# sourceMappingURL=get-config-file.js.map